#include <windows.h>
#include <DbgHelp.h>
#include <stdio.h>

int main() {
  STARTUPINFO startup_info = {0};
  PROCESS_INFORMATION process_info;
  if (!CreateProcess("dumpee.exe",
		     NULL,
		     NULL,
		     NULL,
		     FALSE,
		     0,
		     NULL,
		     NULL,
		     &startup_info, &process_info))
    return 1;

  HANDLE process = process_info.hProcess;
  DWORD processId = process_info.dwProcessId;

  puts("created process");

  HANDLE dump_file = CreateFile("test.dmp",
				GENERIC_WRITE,
				0,  // no sharing
				NULL,
				CREATE_NEW,  // fail if exists
				FILE_ATTRIBUTE_NORMAL,
				NULL);
  if (dump_file == INVALID_HANDLE_VALUE)
    return 1;

  puts("created dump file");

  MINIDUMP_EXCEPTION_INFORMATION except_info;
  except_info.ThreadId = 0;
  except_info.ExceptionPointers = NULL;
  except_info.ClientPointers = FALSE;

  // Leave room in user_stream_array for possible breakpad and
  // assertion info streams.
  MINIDUMP_USER_STREAM user_stream_array[2];
  MINIDUMP_USER_STREAM_INFORMATION user_streams;
  user_streams.UserStreamCount = 0;
  user_streams.UserStreamArray = user_stream_array;

  // The explicit comparison to TRUE avoids a warning (C4800).
  if (!MiniDumpWriteDump(process,
			 processId,
			 dump_file,
			 MiniDumpNormal,
			 NULL,
			 &user_streams,
			 NULL))
    return 1;
  CloseHandle(dump_file);

  puts("wrote dump");

  return 0;
}
